Areas/ACC/Controllers/ACC_AccountVoucherController.cs
using API_Consume.Areas.ACC.Models;
using API_Consume.BAL;
using API_Consume.CF;
using API_Consume.DAL;
using AutoMapper;
using Microsoft.AspNetCore.Mvc;
using System.Data;

namespace API_Consume.Areas.ACC.Controllers
{
	[CheckAccess]
    [Area("ACC")]
	[Route("[Controller]/[action]")]
	public class ACC_AccountVoucherController : Controller
	{
		#region 10.0 Local Variables
		ACC_AccountVoucherBAL balACC_AccountVoucher = new ACC_AccountVoucherBAL();
        #endregion 10.0 Local Variables

        #region Constructor
        #endregion Constructor

        #region List Page Methods

        #region 11.0 Page Load Event - Index - List Page 
        public IActionResult Index()
		{
			FillDropDownList();
			return View();
		}
		#endregion

		#region Search Result
		[HttpPost]
		[ValidateAntiForgeryToken]
		public IActionResult _SearchResult(ACC_AccountVoucherModel modelACC_AccountVoucher)
		{
			UserOperationRightsModel vUserOperationRightsModel = UserOperationRights.CheckForOperation(ControllerContext);
			ViewBag.UserOperationRights = vUserOperationRightsModel;

			#region 12.2 Set Default Value
			ViewBag.SearchResultHeaderText = CV.SearchResultHeaderText;

			modelACC_AccountVoucher.F_PageNo = modelACC_AccountVoucher.F_PageNo == null ? 1 : modelACC_AccountVoucher.F_PageNo;
			modelACC_AccountVoucher.F_PageSize = modelACC_AccountVoucher.F_PageSize == null ? 25 : modelACC_AccountVoucher.F_PageSize;
			#endregion 12.2 Set Default Value            

			//modelACC_AccountVoucher.F_PageNo = 1;
			//modelACC_AccountVoucher.F_PageSize = 25;

			var vAccountVoucherList = balACC_AccountVoucher.dbo_PR_ACC_AccountVoucher_SelectAll(modelACC_AccountVoucher);

			PagedListPagerModel vPagedListPager = new PagedListPagerModel(vAccountVoucherList.First().TotalRecords, Convert.ToInt32(modelACC_AccountVoucher.F_PageNo), Convert.ToInt32(modelACC_AccountVoucher.F_PageSize));
			vPagedListPager.PageInfo = Pagination.GetPageInformation(vPagedListPager);
			vPagedListPager.PageSizeList = Pagination.GetPagedListPageSizes();

			var vModel = new Tuple<ACC_AccountVoucherModel, PagedListPagerModel, List<dbo_PR_ACC_AccountVoucher_SelectAll_Result>>(modelACC_AccountVoucher, vPagedListPager, vAccountVoucherList);

			return PartialView("_ACC_AccountVoucherList", vModel);
		}
		#endregion Search Result

		#region ExportExcel
		[HttpPost]
		[ValidateAntiForgeryToken]
		public IActionResult ExportExcel(ACC_AccountVoucherModel modelACC_AccountVoucher, int TotalRecords)
		{
			UserOperationRightsModel vUserOperationRightsModel = UserOperationRights.CheckForOperation(ControllerContext);
			ViewBag.UserOperationRights = vUserOperationRightsModel;

			modelACC_AccountVoucher.F_PageNo = 1;
			modelACC_AccountVoucher.F_PageSize = TotalRecords;
			var vAccountVoucherList = balACC_AccountVoucher.dbo_PR_ACC_AccountVoucher_SelectAll(modelACC_AccountVoucher);

			DataTable dt = EntityToDataTable.ConvertToDataTable(vAccountVoucherList);

			var contentType = "application/vnmodelACC_AccountVoucher.openxmlformats-officedocument.spreadsheetml.sheet";
			var fileName = "AccountVoucherList.xlsx";

			return File(CommonFunctions.DownloadExcel(dt, "Chapter").ToArray(), contentType, fileName);
		}
		#endregion ExportExcel

		#region _Delete
		[HttpPost]
		[ValidateAntiForgeryToken]
		public IActionResult _Delete(int AccountVoucherID)
		{
			bool vReturen = balACC_AccountVoucher.dbo_PR_ACC_AccountVoucher_Delete(AccountVoucherID);
			return RedirectToAction("Index");
		}
		#endregion

		#endregion List Page Methods

		#region FillLabels
		private void FillLabels(ControllerContext controllerContext)
		{
			var CurrentArea = controllerContext.RouteData.Values["area"].ToString();
			var CurrentController = controllerContext.RouteData.Values["controller"].ToString();
			var CurrentAction = controllerContext.RouteData.Values["action"].ToString();
			ViewBag.lblAccountVoucherName = "Account Voucher";
		}
		#endregion FillLabels

		#region Fill DropDown List
		private void FillDropDownList()
		{
			ViewBag.AccountList = CommonFillMethods.FillDropDownListAccountID();
			ViewBag.AccountDocList = CommonFillMethods.FillDropDownListAccountDocID();
		}
		#endregion

		#region 11.0 Page Load Event - Add/Edit
		public IActionResult AddEdit(int? AccountVoucherID)
		{
			#region 11.2 IsAdd, IsEdit Rights
			UserOperationRightsModel vUserOperationRightsModel = UserOperationRights.CheckForOperation(ControllerContext);
			ViewBag.UserOperationRights = vUserOperationRightsModel;

			if (!vUserOperationRightsModel.IsAdd && !vUserOperationRightsModel.IsEdit)
			{
				return RedirectToAction("Index", "Error", new { Area = "" });
			}
			else if (vUserOperationRightsModel.IsAdd && !vUserOperationRightsModel.IsEdit && AccountVoucherID != null)
			{
				return RedirectToAction("Index", "Error", new { Area = "" });
			}
			else if (!vUserOperationRightsModel.IsAdd && vUserOperationRightsModel.IsEdit && AccountVoucherID == null)
			{
				return RedirectToAction("Index", "Error", new { Area = "" });
			}
			#endregion 11.2 IsAdd, IsEdit Rights    

			#region 11.2 Fill Lables
			FillLabels(ControllerContext);
			#endregion 11.2 Fill Lables            

			#region 11.3 Dropdown List Fill Section
			FillDropDownList();
			#endregion 11.3 Dropdown List Fill Section

			#region 11.4 Set Control Default Value
			ACC_AccountVoucherModel AccountVoucherModel = new ACC_AccountVoucherModel();
			#endregion 11.4 Set Control Default Value

			if (AccountVoucherID != null || AccountVoucherID > 0)
			{
				ViewBag.Action = "Edit";

				var d = balACC_AccountVoucher.dbo_PR_ACC_AccountVoucher_SelectByPk(AccountVoucherID).SingleOrDefault();
				//var d = balACC_AccountVoucher.dbo_PR_ACC_AccountVoucher_SelectByPk(AccountVoucherID);

				Mapper.Initialize(config => config.CreateMap<API_Consume.DAL.dbo_PR_ACC_AccountVoucher_SelectByPK_Result, ACC_AccountVoucherModel>());
				var vModel = AutoMapper.Mapper.Map<API_Consume.DAL.dbo_PR_ACC_AccountVoucher_SelectByPK_Result, ACC_AccountVoucherModel>(d);

				return View("ACC_AccountVoucherAddEdit", vModel);
				//var data = await balACC_AccountVoucher.ACC_AccountVoucher_SelectByPk(AccountVoucherID);
				//return View("ACC_AccountVoucherAddEdit", data);
			}
			ViewBag.Action = "Add";
			return View("ACC_AccountVoucherAddEdit", AccountVoucherModel);
			//ViewBag.Action = "Add";
			//return View("ACC_AccountVoucherAddEdit",null);
		}
		#endregion 11.0 Page Load Event - Add/Edit

		#region 15.0 Save Button Event
		[HttpPost]
		[ValidateAntiForgeryToken]
		public IActionResult _Save(ACC_AccountVoucherModel modelACC_AccountVoucher)
		{
			try
			{
				#region Validate Field
				string errorMsg = "";
				if (modelACC_AccountVoucher.AccountDocID == null)
				{
					errorMsg += "<li>Select Account Doc</li>";
				}
				if (modelACC_AccountVoucher.VoucherNo == null)
				{
					errorMsg += "<li>Enter Voucher No</li>";
				}
				if (errorMsg != "")
				{
					TempData["ErrorMessage"] = errorMsg;
					return View("ACC_AccountVoucherAddEdit", modelACC_AccountVoucher);
				}
				#endregion Validate Field

				#region Gather Data
				#endregion Gather Data

				if (modelACC_AccountVoucher.AccountVoucherID == 0)
				{
					bool vReturn = balACC_AccountVoucher.dbo_PR_ACC_AccountVoucher_Insert(modelACC_AccountVoucher);
					if (vReturn)
					{
						TempData["SuccessMessage"] = "Record Inserted Successfully..!";
					}
					else
					{
						TempData["ErrorMessage"] = "Some Error Has Occured..!";
					}
				}
				else
				{
					bool vReturn = balACC_AccountVoucher.dbo_PR_ACC_AccountVoucher_Update(modelACC_AccountVoucher);
					if (vReturn)
					{
						TempData["SuccessMessage"] = "Record Updated Successfully..!";
					}
					else
					{
						TempData["ErrorMessage"] = "Some Error Has Occured..!";
					}
				}

				return RedirectToAction("Index");
			}
			catch (Exception ex)
			{
				TempData["ErrorMessage"] = ex.Message;
				return View("ACC_AccountVoucherAddEdit", modelACC_AccountVoucher);
			}
		}
		#endregion 15.0 Save Button Event

	}
}

Areas/ACC/Views/Shared/_ACC_AccountVoucherList.cshtml
@using API_Consume.CF;
@using API_Consume.BAL;
@using API_Consume.DAL;
@using API_Consume.Areas.ACC.Models;
@using static API_Consume.DAL.ACC_AccountVoucherDALBase;
@model Tuple<ACC_AccountVoucherModel, PagedListPagerModel, List<dbo_PR_ACC_AccountVoucher_SelectAll_Result>>

@{
    UserOperationRightsModel vUserOperationRightsModel = ViewBag.UserOperationRights;
}

<div id="kt_app_content" class="app-content flex-column-fluid">
    <!--begin::Content container-->
    <div id="kt_app_content_container" class="app-container container-fluid">
        <!--begin::Card-->
        <div class="card">
            <!--begin::Card header-->
            <div class="card-header border-0">
                <!--begin::Card toolbar-->
                <div class="card-toolbar">
                    <!--begin::Toolbar-->
                    <div class="d-flex justify-content-end pt-md-3" data-kt-customer-table-toolbar="base">
                        <!--begin::Title-->
                        <div class="d-flex justify-content-center">
                            <div>
                                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-search" viewBox="0 0 16 16">
                                    <path d="M11.742 10.344a6.5 6.5 0 1 0-1.397 1.398h-.001q.044.06.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1 1 0 0 0-.115-.1zM12 6.5a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0" />
                                </svg>
                            </div>

                            <div class="mx-2">
                                <h3 class="text-dark ">
                                    <span class="text-dark">@ViewBag.SearchResultHeaderText</span>
                                </h3>
                            </div>

                        </div>
                        <!--end::Title-->
                    </div>
                    <!--end::Toolbar-->
                </div>
                <!--end::Card toolbar-->
                <!--begin::Card title-->
                <div class="card-title">
                    <div class="d-flex justify-content-center">
                        <div>
                            <a asp-area="ACC" asp-action="AddEdit" asp-controller="ACC_AccountVoucher" class="btn btn-sm btn-success">
                                <i class="fa fa-plus"></i> Add Account Voucher
                            </a>
                        </div>

                        <!--begin::Download Excel-->
                        <div style="padding-left:10px;">
                            <form id="frmExportExcel" class="" target="_blank"
                                  asp-action="ExportExcel" asp-controller="ACC_AccountVoucher" asp-area="ACC">
                                @Html.AntiForgeryToken()
                                <input type="hidden" id="TotalRecords" class="" name="TotalRecords" value="@(Model.Item3.First().TotalRecords)" />
                                <button type="submit" class="btn btn-sm btn-success">
                                    Export Excel
                                </button>
                            </form>
                        </div>
                        <!--end::Download Excel-->
                    </div>
                </div>
                <!--begin::Card title-->
            </div>
            <hr />
            <!--end::Card header-->
            <div class="card-body pt-0">
                <div class="row">
                    <div class="col-md-12">
                        <partial name="/Views/Error/_ucShowInfo.cshtml" />
                    </div>
                </div>
                <div class="col-md-12" id="divCityList">


                    <form id="hdFormUpdateCityList" class="" data-ajax="true" data-ajax-method="post" data-ajax-mode="replace" data-ajax-update="#SearchResult"
                          data-ajax-success="OnSuccess(this.id,data, status, xhr);" data-ajax-failure="OnFailure(xhr, status, error);"
                          asp-action="_SearchResult" asp-controller="ACC_AccountVoucher" asp-area="ACC">
                        @Html.AntiForgeryToken()
                        <div class="row" style="margin-bottom: 10px;">
                            <div class="col-md-7">
                                Page size: @Html.DropDownList("F_PageSize", Model.Item2.PageSizeList, new { @class = "form-select js-grid-hd-input", style = "display: inline; width: 65px; height: 30px; padding: 0px 4px; padding-top: 2px; padding-bottom: 6px;" })
                                <div class="d-inline-bMEMk">@Html.Raw(Model.Item2.PageInfo)</div>
                            </div>

                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <input type="hidden" id="GoToPageNo" class="js-grid-hd-input" name="F_PageNo" value="@(Model.Item1.F_PageNo)" />
                            </div>
                        </div>
                    </form>
                    <div class="table-responsive">
                        <table class="table table-bordered table-hover" id="tblList">
                            <thead class="table-secondary">
                                <tr class="fw-bold">
                                    <th width="10%">Account Doc</th>
                                    <th width="8%">Voucher No.</th>
                                    <th width="10%">Voucher Date</th>
                                    <th width="8%">Amount</th>
                                    <th>Debit Account</th>
                                    <th>Credit Account</th>
                                    <th width="5%">User</th>
                                    <th width="8%">Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                @{
                                    int i = 0;
                                }
                                @if (Model.Item3.Count == 0)
                                {
                                    <tr class="text-center">
                                        <td colspan="8">No records found...!</td>
                                    </tr>
                                }
                                @foreach (var item in Model.Item3)
                                {
                                    i++;
                                    <tr>
                                        <td>@item.AccountDocName</td>
                                        <td>@item.VoucherNo</td>
                                        <td>@Convert.ToDateTime(item.VoucherDate).ToString("dd-MM-yyyy")</td>
                                        <td>@item.Amount</td>
                                        <td>@item.DebitAccountName</td>
                                        <td>@item.CreditAccountName</td>
                                        <td>@item.UserName</td>
                                        <td class="text-center">
                                            @if (vUserOperationRightsModel.IsEdit)
                                            {
                                                <span data-bs-toggle="tooltip" data-bs-placement="left" title="Edit">
                                                    <a asp-area="ACC" asp-action="AddEdit" asp-controller="ACC_AccountVoucher" asp-route-AccountVoucherID="@item.AccountVoucherID" class="btn btn-primary btn-icon btn-elevate btn-sm">
                                                        <i class="fa fa-pencil"></i>
                                                    </a>
                                                </span>
                                            }

                                            @if (vUserOperationRightsModel.IsDelete)
                                            {
                                                <form method="post" asp-area="ACC" asp-action="_Delete" asp-controller="ACC_AccountVoucher" style="display: inline;">
                                                    @Html.AntiForgeryToken()
                                                    <input type="hidden" name="AccountVoucherID" value="@item.AccountVoucherID" />
                                                    <a class="btn btn-danger btn-icon btn-elevate btn-sm js-bb-confirm-delete" data-bs-toggle="tooltip" data-bs-placement="left" title="Delete"><i class="fa fa-trash"></i></a>
                                                </form>
                                            }
                                        </td>
                                    </tr>
                                }
                            </tbody>
                        </table>
                    </div>
                    <div class="text-end pull-end">
                        <partial name="/Views/Shared/_GeneratePager.cshtml" model="@Model.Item2" />
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<script>
    $(".js-grid-hd-input").on("change", function () {
        $("#hdFormUpdateCityList").submit();
    });
</script>

Areas/ACC/Views/Shared/_ACC_AccountVoucherListFilterForm.cshtml
@using API_Consume.CF;
@using API_Consume.BAL;
@model API_Consume.Areas.ACC.Models.ACC_AccountVoucherModel;

<div class="row g-mb-20">
    <div class="col-md-12" id="divBranchList">
        <form id="filterForm" class="filter-form" data-ajax="true" data-ajax-method="post" data-ajax-mode="replace"
              data-ajax-update="#SearchResult" data-ajax-success="OnSuccess(this.id,data, status, xhr);"
              data-ajax-failure="OnFailure(xhr, status, error);" asp-action="_SearchResult" asp-controller="ACC_AccountVoucher"
              asp-area="ACC">
            @Html.AntiForgeryToken()


            <div class="row">
                <div class="col-md-3">
                    <div class="form-group">
                        @Html.LabelFor(x => x.F_AccountDocID)
                        <div class="input-group flex-nowrap">
                            <span class="input-group-text"><i class="fa fa-search"></i></span>
                            <select class="form-control" data-control="select2" asp-for="F_AccountDocID"
                                    asp-items="@(new SelectList(ViewBag.AccountDocList,"AccountDocID","AccountDocName"))">
                                <option value="">Select AccountDoc</option>
                            </select>
                            @Html.ValidationMessageFor(m => m.F_AccountDocID, "", new { @class = "form-text text-danger" })
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        @Html.LabelFor(x => x.F_VoucherNo)
                        <div class="input-group flex-nowrap">
                            <span class="input-group-text"><i class="fa fa-search"></i></span>
                            <input type="text" asp-for="F_VoucherNo" class="form-control" />
                            @Html.ValidationMessageFor(m => m.F_VoucherNo, "", new { @class = "form-text text-danger" })
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        @Html.LabelFor(x => x.F_FromDate)
                        <div class="input-group flex-nowrap">
                            <span class="input-group-text"><i class="fas fa-calendar-alt"></i></span>
                            <input type="date" asp-for="F_FromDate" class="form-control" />
                            @Html.ValidationMessageFor(m => m.F_FromDate, "", new { @class = "form-text text-danger" })
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        @Html.LabelFor(x => x.F_ToDate)
                        <div class="input-group flex-nowrap">
                            <span class="input-group-text"><i class="fas fa-calendar-alt"></i></span>
                            <input type="date" asp-for="F_ToDate" class="form-control" />
                            @Html.ValidationMessageFor(m => m.F_ToDate, "", new { @class = "form-text text-danger" })
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        @Html.LabelFor(x => x.F_DebitAccountName)
                        <div class="input-group flex-nowrap">
                            <span class="input-group-text"><i class="fa fa-search"></i></span>
                            <input type="text" asp-for="F_DebitAccountName" class="form-control" />
                            @Html.ValidationMessageFor(m => m.F_DebitAccountName, "", new { @class = "form-text text-danger" })
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        @Html.LabelFor(x => x.F_CreditAccountName)
                        <div class="input-group flex-nowrap">
                            <span class="input-group-text"><i class="fa fa-search"></i></span>
                            <input type="text" asp-for="F_CreditAccountName" class="form-control" />
                            @Html.ValidationMessageFor(m => m.F_CreditAccountName, "", new { @class = "form-text text-danger" })
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        @Html.LabelFor(x => x.F_Narration)
                        <div class="input-group flex-nowrap">
                            <span class="input-group-text"><i class="fa fa-search"></i></span>
                            <input type="text" asp-for="F_Narration" class="form-control" />
                            @Html.ValidationMessageFor(m => m.F_Narration, "", new { @class = "form-text text-danger" })
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        @Html.LabelFor(x => x.F_Remarks)
                        <div class="input-group flex-nowrap">
                            <span class="input-group-text"><i class="fa fa-search"></i></span>
                            <input type="text" asp-for="F_Remarks" class="form-control" />
                            @Html.ValidationMessageFor(m => m.F_Remarks, "", new { @class = "form-text text-danger" })
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-md-3">
                <div class="form-group">
                    <label class="">&nbsp;</label>
                    <div>
                        <input class="btn btn-primary btn-action-search" type="submit" value="Show" name="btnShow"
                               id="btnShow" />
                        <input type="reset" value="Reset" class="btn btn-light btn-action-reset" />
                    </div>
                </div>
            </div>
        </form>
    </div>

</div>